<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method = "text" />
<xsl:template match="dns" xml:space="preserve"> 
<xsl:template match="options" xml:space="preserve"> 
## named.conf - configuration for bind
#
# Generated automatically by redhat-config-bind, alchemist et al.
# Any changes not supported by redhat-config-bind should be put 
# in /etc/named.custom
#
controls {
        inet 127.0.0.1 allow { localhost; } keys { rndckey; };
};
 
include "/etc/named.custom";

include "/etc/rndc.key";

options { 
	<xsl:for-each select="options/directory">directory "<xsl:value-of select="@VALUE" />"; 	</xsl:for-each>
};

</xsl:template>

<xsl:for-each select="slavezonelist/slavezone">zone "<xsl:value-of select="name/@VALUE" />" { 
	type slave; 
	file "<xsl:value-of select="file/@VALUE" />";
	masters { 
		<xsl:for-each select="masters/ip"> <xsl:value-of select="@VALUE" />;
		</xsl:for-each>}; 
};
</xsl:for-each>

<xsl:for-each select="forwardzonelist/forwardzone">zone "<xsl:value-of select="name/@VALUE" />" { 
	type forward; 
	forwarders { 
		<xsl:for-each select="forwarders/ip"> <xsl:value-of select="@VALUE" />; 
		</xsl:for-each> }; 
};
</xsl:for-each>

<xsl:for-each select="hintzonelist/hintzone">zone  "<xsl:value-of select="name/@VALUE" />" { 
	type hint; 
	file  "<xsl:value-of select="file/@VALUE" />";
};
</xsl:for-each>

<xsl:for-each select="mreversezonelist/mreversezone">zone  "<xsl:value-of select="name/@VALUE" />" { 
	type master; 
	file  "<xsl:value-of select="file/@VALUE" />"; 
};
</xsl:for-each>

<xsl:for-each select="mforwardzonelist/mforwardzone">zone  "<xsl:value-of select="name/@VALUE" />" { 
	type master; 
	file  "<xsl:value-of select="file/@VALUE" />"; 
};
</xsl:for-each>


</xsl:template>


</xsl:stylesheet>
