<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method = "text" />
<xsl:template match="dns/mforwardzonelist" xml:space="preserve"> 
<xsl:for-each select="mforwardzone">
--------CUTFILEHERE: /var/named/<xsl:value-of select="file/@VALUE" />
$TTL <xsl:value-of select="soa/minimum/@VALUE" />
@	IN	SOA	<xsl:value-of select="soa/pns/@VALUE" />  <xsl:value-of select="soa/contact/@VALUE" /> (
			<xsl:value-of select="soa/serial/@VALUE" /> ; serial
			<xsl:value-of select="soa/refresh/@VALUE" /> ; refresh
			<xsl:value-of select="soa/retry/@VALUE" /> ; retry
			<xsl:value-of select="soa/expire/@VALUE" /> ; expire	
			<xsl:value-of select="soa/minimum/@VALUE" /> ; ttl
			)

<xsl:for-each select="nslist/ns">
<xsl:value-of select="appliesto/@VALUE" />	IN	NS	<xsl:value-of select="host/@VALUE" /></xsl:for-each>
<xsl:for-each select="mxlist/mx">
<xsl:value-of select="appliesto/@VALUE" />	IN	MX	<xsl:value-of select="priority/@VALUE" />	<xsl:value-of select="host/@VALUE" /></xsl:for-each>
<xsl:for-each select="alist/a">
<xsl:value-of select="host/@VALUE" />	IN	A	<xsl:value-of select="ip/@VALUE" /></xsl:for-each>
<xsl:for-each select="cnamelist/cname">
<xsl:value-of select="alias/@VALUE" />	IN	CNAME	<xsl:value-of select="host/@VALUE" /></xsl:for-each>
--------ENDFILEHERE
</xsl:for-each>
</xsl:template>


<xsl:template match="dns/mreversezonelist" xml:space="preserve"> 
<xsl:for-each select="mreversezone">
--------CUTFILEHERE: /var/named/<xsl:value-of select="file/@VALUE" />
$TTL <xsl:value-of select="soa/minimum/@VALUE" />
@	IN	SOA	<xsl:value-of select="soa/pns/@VALUE" />	<xsl:value-of select="soa/contact/@VALUE" /> (
			<xsl:value-of select="soa/serial/@VALUE" /> ; serial
			<xsl:value-of select="soa/refresh/@VALUE" /> ; refresh
			<xsl:value-of select="soa/retry/@VALUE" /> ; retry
			<xsl:value-of select="soa/expire/@VALUE" /> ; expire	
			<xsl:value-of select="soa/minimum/@VALUE" /> ; ttk
			)

<xsl:for-each select="nslist/ns">
<xsl:value-of select="appliesto/@VALUE" />	IN	NS	<xsl:value-of select="host/@VALUE" /></xsl:for-each>
<xsl:for-each select="ptrlist/ptr">
<xsl:value-of select="ip/@VALUE" />	IN	PTR	<xsl:value-of select="host/@VALUE" /></xsl:for-each>
--------ENDFILEHERE
</xsl:for-each>
</xsl:template>
</xsl:stylesheet>
